﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

namespace WpfApplication2
{
    public class AllObjectTwos
    {
        private int BlockSize = 100;
        public int Min { get; private set; }
        public int Max { get; private set; }
        public int Buffer { get { return 25; } }
        public int TotalCount = 10000;
        
        public ObservableCollection<ObjectTwo> AllTwos { get; private set; }

        public AllObjectTwos()
        {
            Min = 1;
            Max = 100;
            AllTwos = new ObservableCollection<ObjectTwo>();
            LoadOnDemand();
        }
        
        public void LoadOnDemand()
        {
            if (Max < TotalCount)
            {
                for (int i = Min; i <= Max; i++)
                {
                    AllTwos.Add(new ObjectTwo(i));
                }
                Min = Min + BlockSize;
                Max = Max + BlockSize;
            }
        }
    }
}
