﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;

namespace WpfApplication2
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private AllObjectOnes ones;
        private AllObjectTwos twos;
        
        public Window1()
        {
            InitializeComponent();
            label2.Content = xamDataGrid1.Records.Count.ToString();
        }

        private void Object1Radio_Checked(object sender, RoutedEventArgs e)
        {
            if (twos != null)
            {
                twos = null;
            }
            ones = new AllObjectOnes();
            DataContext = ones;
            xamDataGrid1.DataSource = ones.AllOnes;
            label1.Content = ones.AllOnes.Count.ToString() + " of " + ones.TotalCount.ToString();
            label2.Content = xamDataGrid1.Records.Count.ToString();
        }

        private void Object2Radio_Checked(object sender, RoutedEventArgs e)
        {
            if (ones != null)
            {
                ones = null;
            }
            twos = new AllObjectTwos();
            DataContext = twos;
            xamDataGrid1.DataSource = twos.AllTwos;
            label1.Content = twos.AllTwos.Count.ToString() + " of " + twos.TotalCount.ToString();
            label2.Content = xamDataGrid1.Records.Count.ToString();
        }

        private void xamDataGrid1_ScrollChanged(object sender, ScrollChangedEventArgs e)
        {
            Infragistics.Windows.DataPresenter.Record[] ViewableRows;
            ViewableRows = xamDataGrid1.GetRecordsInView(false);
            if (ones != null)
            {
                if (ViewableRows[ViewableRows.Length - 1].Index + ones.Buffer >= ones.AllOnes.Count)
                {
                    ones.LoadOnDemand();
                }
                label1.Content = ones.AllOnes.Count.ToString() + " of " + ones.TotalCount.ToString();
                label2.Content = xamDataGrid1.Records.Count.ToString();
            }
            else if (twos != null)
            {
                if (ViewableRows[ViewableRows.Length - 1].Index + twos.Buffer >= twos.AllTwos.Count)
                {
                    twos.LoadOnDemand();
                }
                label1.Content = twos.AllTwos.Count.ToString() + " of " + twos.TotalCount.ToString();
                label2.Content = xamDataGrid1.Records.Count.ToString();
            }            
        }

        private void xamDataGrid1_RecordAdded(object sender, Infragistics.Windows.DataPresenter.Events.RecordAddedEventArgs e)
        {
            label2.Content = xamDataGrid1.Records.Count.ToString();    
        }
    }
}
