﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

namespace WpfApplication2
{
    public class AllObjectOnes
    {
        private int BlockSize = 100;
        public int Min { get; private set; }
        public int Max { get; private set; }
        public int Buffer { get { return 25; } }
        public int TotalCount = 10000;

        public ObservableCollection<ObjectOne> AllOnes { get; private set; }

        public AllObjectOnes()
        {
            Min = 1;
            Max = 100;
            AllOnes = new ObservableCollection<ObjectOne>();
            LoadOnDemand();
        }

        public void LoadOnDemand()
        {
            if (Max < TotalCount)
            {
                for (int i = Min; i <= Max; i++)
                {
                    AllOnes.Add(new ObjectOne(i));
                }
                Min = Min + BlockSize;
                Max = Max + BlockSize;
            }
        }
    }
}
